Java异常处理的20个最佳实践:告别系统崩溃
  UxvP3mLKJea9 2024年02月22日 19 0

引言

在Java编程中,异常处理是一个至关重要的环节,它不仅涉及到程序的稳定性和安全性,还关系到用户体验和系统资源的合理利用。合理的异常处理能够使得程序在面对不可预知错误时,能够优雅地恢复或者给出明确的反馈,而不是简单地崩溃退出。

文章开始前,我们先看下思维导图熟悉下有哪些异常

正文

1、尽量不要捕获 RuntimeException(Unchecked Exception)

阿里巴巴Java开发手册上这样规定:

尽量不要 catch RuntimeException,比如 NullPointerException、IndexOutOfBoundsException 等等,应该用预检查的方式来规避。

正例

if (obj != null) {
  //...
}
 " + (a / b));
}

反例

try { 
  obj.method(); 
} catch (NullPointerException e) {
  //...
}

如果有些异常预检查不出来呢?比如说 NumberFormatException,虽然也属于 RuntimeException,但没办法预检查,所以还是应该用 catch 捕获处理。

2、 切勿在代码中使用异常来进行流程控制

异常应当是在真正的异常情况下使用,而不是用来控制程序流程。

public class Demo {
    public static void main(String[] args) {
        String input = "1,2,3,a,5";
        String[] values = input.split(",");
        for (String value : values) {
            try {
                int num = Integer.parseInt(value);
                System.out.println(num);
            } catch (NumberFormatException e) {
                System.err.println(value + " is not a valid number");
            }
        }
    }
}

}

3、 合理利用finally块

确保在finally块中释放资源,比如关闭文件流或数据库连接,无论是否发生异常。

FileInputStream file = null;
try {
    file = new FileInputStream("someFile.txt");
    // 使用文件流
} catch (IOException e) {
    e.printStackTrace();
} finally {
    if (file != null) {
        try {
            file.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
}

4、 不要在finally块中使用return

这会导致try块中的return语句被忽略。

public int notGood() {
    try {
        // 假设这里有逻辑代码
        return 1;
    } finally {
        return 2;
    }
}

5、 避免忽略异常

即使认为某些异常不重要也不应该完全忽略它们,至少要记录下来。

反例

public void doNotIgnoreExceptions() {
    try {
    } catch (NumberFormatException e) {
        // 没有记录异常
    }
}

正例

public void logAnException() {
    try {
    } catch (NumberFormatException e) {
        log.error("哦,错误竟然发生了: " + e);
    }
}

6、 捕获具体的子类而不是捕获 Exception 类

对不同类型的异常给出不同的处理逻辑。

反例

try {
   someMethod();
} catch (Exception e) { //错误方式
   LOGGER.error("method has failed", e);
}

正例

try {
    // 某些可能产生异常的操作
} catch (FileNotFoundException e) {
    // 文件未找到的处理逻辑
} catch (IOException e) {
    // IO异常的处理逻辑
}

7、 将所有相关信息尽可能地传递给异常

有用的异常消息和堆栈跟踪非常重要,如果你的日志不能定位异常位置,那要日志有什么用呢?

try {
    // 某些可能产生异常的操作
} catch (IOException | SQLException e) {
 // Log exception message and stack trace
    LOGGER.debug("Error reading file", e);
}

应该尽量把 String message, Throwable cause 异常信息和堆栈都输出。

8、 使用自定义异常传递更多信息

当内置的异常类型不能满足需求时,可以创建自定义异常。

public class MyException extends Exception {
    public MyException(String message) {
        super(message);
    }
}

public void doSomething() throws MyException {
    // 某些逻辑
    throw new MyException("特定错误信息");
}

9、 自定义异常时不要丢失堆栈跟踪

在捕获一个异常并抛出另一个异常时,保留原始异常的信息。

catch (NoSuchMethodException e) {
  //错误方式 
 throw new MyServiceException("Some information: " + e.getMessage());
}

这破坏了原始异常的堆栈跟踪,正确的做法是:

catch (NoSuchMethodException e) {
 //正确方式 
 throw new MyServiceException("Some information: " , e); 
}

10、优先使用标准异常

在可能的情况下,应优先使用Java标准库中定义的异常。

public void setValue(int value) {
    if (value < 0) {
        throw new IllegalArgumentException("值不能为负"); // 使用标准异常
    }
    // 设置值的逻辑
}

11、不要在生产环境中使用 printStackTrace()

在 Java 中,printStackTrace() 方法用于将异常的堆栈跟踪信息输出到标准错误流中。这个方法对于调试和排错非常有用。但在生产环境中,不应该使用 printStackTrace() 方法,因为它可能会导致以下问题:

  • printStackTrace() 方法将异常的堆栈跟踪信息输出到标准错误流中,这可能会暴露敏感信息,如文件路径、用户名、密码等。
  • printStackTrace() 方法会将堆栈跟踪信息输出到标准错误流中,这可能会影响程序的性能和稳定性。在高并发的生产环境中,大量的异常堆栈跟踪信息可能会导致系统崩溃或出现意外的行为。
  • 由于生产环境中往往是多线程、分布式的复杂系统,printStackTrace() 方法输出的堆栈跟踪信息可能并不完整或准确。

在生产环境中,应该使用日志系统来记录异常信息,例如** log4j、slf4j、logback**等。日志系统可以将异常信息记录到文件或数据库中,而不会暴露敏感信息,也不会影响程序的性能和稳定性。同时,日志系统也提供了更多的功能,如级别控制、滚动日志、邮件通知等。

//例如,可以使用 logback 记录异常信息,如下所示:
try {
    // some code
} catch (Exception e) {
    logger.error("An error occurred: ", e);
}

12、 不要捕获 Throwable

Throwable 是 exception 和 error 的父类,如果在 catch 子句中捕获了 Throwable,很可能把超出程序处理能力之外的错误也捕获了。

public void doNotCatchThrowable() {
    try {
    } catch (Throwable t) {
        // 不要这样做
    }
}

13、利用try-with-resources自动管理资源

Java 7引入的try-with-resources语句可以自动管理资源,减少代码冗余。

try (FileInputStream input = new FileInputStream("file.txt")) {
    // 使用资源
} catch (IOException e) {
    e.printStackTrace();
}

14、为异常提供详细的上下文信息

在抛出异常时,提供足够的上下文信息,以帮助定位和解决问题。

public void loadConfiguration(String path) throws IOException {
    try {
        // 加载配置逻辑
    } catch (IOException e) {
        throw new IOException("加载配置文件失败,路径:" + path, e);
    }
}

15、不要记录了异常又抛出了异常

这纯属画蛇添足,并且容易造成错误信息的混乱。

反例:

try {
} catch (NumberFormatException e) {
    log.error(e);
    throw e;
}

要抛出就抛出,不要记录,记录了又抛出,等于多此一举。

正例:

public void wrapException(String input) throws MyBusinessException {
    try {
    } catch (NumberFormatException e) {
        throw new MyBusinessException("错误信息描述:", e);
    }
}

16、finally 块中不要抛出任何异常

try {
  someMethod();  //Throws exceptionOne
} finally {
  cleanUp();    //如果finally还抛出异常,那么exceptionOne将永远丢失
}

finally 块用于定义一段代码,无论 try 块中是否出现异常,都会被执行。finally 块通常用于释放资源、关闭文件等必须执行的操作。

如果在 finally 块中抛出异常,可能会导致原始异常被掩盖。比如说上例中,一旦 cleanup 抛出异常,someMethod 中的异常将会被覆盖

17、只抛出和方法相关的异常

相关性对于保持代码的整洁非常重要。一种尝试读取文件的方法,如果抛出 NullPointerException,那么它不会给用户提供有价值的信息。相反,如果这种异常被包裹在自定义异常中,则会更好。NoSuchFileFoundException 则对该方法的用户更有用。

public class Demo {
    public static void main(String[] args) {
        try {
            int result = divide(10, 0);
            System.out.println("The result is: " + result);
        } catch (ArithmeticException e) {
            System.err.println("Error: " + e.getMessage());
        }
    }

    public static int divide(int a, int b) throws ArithmeticException {
        if (b == 0) {
            throw new ArithmeticException("Division by zero");
        }
        return a / b;
    }
}

18、尽早验证用户输入以在请求处理的早期捕获异常

再好的异常捕获不如没有异常,所以我们在业务开发中,可以提前验证用户输入,以在请求处理的早期就捕获处理异常

举个例子,我们用 JDBC 的方式往数据库插入数据,那么最好是先 validate 再 insert,而不是 validateUserInput、insertUserData、validateAddressInput、insertAddressData。

Connection conn = null;
try {
    // Connect to the database
    conn = DriverManager.getConnection("jdbc:mysql://localhost:3306/mydatabase", "username", "password");

    // Start a transaction
    conn.setAutoCommit(false);

    // Validate user input
    validateUserInput();

    // Insert user data
    insertUserData(conn);

    // Validate address input
    validateAddressInput();

    // Insert address data
    insertAddressData(conn);

    // Commit the transaction if everything is successful
    conn.commit();

} catch (SQLException e) {
    // Rollback the transaction if there is an error
    if (conn != null) {
        try {
            conn.rollback();
        } catch (SQLException ex) {
            System.err.println("Error: " + ex.getMessage());
        }
    }
    System.err.println("Error: " + e.getMessage());
} finally {
    // Close the database connection
    if (conn != null) {
        try {
            conn.close();
        } catch (SQLException e) {
            System.err.println("Error: " + e.getMessage());
        }
    }
}

19、 一个异常只能包含在一个日志中

反例

log.debug("Using redis one");
log.debug("Using redis two");

在单线程环境中,这样看起来没什么问题,但如果在多线程环境中,这两行紧挨着的代码中间可能会输出很多其他的内容,导致问题查起来会很难受。应该这样做:

LOGGER.debug("Using redis one, Using redis two");

20、对于不打算处理的异常,直接使用 try-finally,不用 catch

try {
  method1();  // 会调用 Method 2
} finally {
  cleanUp();    //do cleanup here
}

如果 method1 正在访问 Method 2,而 Method 2 抛出一些你不想在 Method 1 中处理的异常,但是仍然希望在发生异常时进行一些清理,可以直接在 finally 块中进行清理,不要使用 catch 块。

总结

有效的异常处理是高质量Java应用开发的基石。也是Java面试中被问频率很高的问题,通过遵循上述20个最佳实践,开发者不仅能够编写出更加健壮和可维护的代码,还能应对面试中面试官的各种关于异常的问题。

最后说一句(求关注,求赞,别白嫖我)

最近无意间获得一份阿里大佬写的刷题笔记,一下子打通了我的任督二脉,进大厂原来没那么难。

这是大佬写的, 7701页的BAT大佬写的刷题笔记,让我offer拿到手软

本文,已收录于,我的技术网站 aijiangsir.com,有大厂完整面经,工作技术,架构师成长之路,等经验分享

求一键三连:点赞、分享、收藏

点赞对我真的非常重要!在线求赞,加个关注我会非常感激![]()

【版权声明】本文内容来自摩杜云社区用户原创、第三方投稿、转载,内容版权归原作者所有。本网站的目的在于传递更多信息,不拥有版权,亦不承担相应法律责任。如果您发现本社区中有涉嫌抄袭的内容,欢迎发送邮件进行举报,并提供相关证据,一经查实,本社区将立刻删除涉嫌侵权内容,举报邮箱: cloudbbs@moduyun.com

  1. 分享:
最后一次编辑于 2024年02月22日 0

暂无评论

推荐阅读
  K5umzhFHgeiy   3天前   13   0   0 Java
  pz9FfsmKHlJb   13小时前   5   0   0 Java
  lrSkukhQvhDW   13小时前   7   0   0 Java
UxvP3mLKJea9